clear all
rng(1); % new way to control random number generation

case_name = 'Case2';

%% Case with gmdp_example_epidemio with no default arguments
[GMDP] = gmdp_example_epidemio(0.8,0.2,0.5,8);
discount = 0.8;


%% Test 1 - Test gmdp_globalize
P1(:,:,1) = [ 0.0080    0.0320    0.0320    0.1280    0.0320    0.1280    0.1280    0.5120
         0    0.0320         0    0.1680         0    0.1280         0    0.6720
         0         0    0.0256    0.1344         0         0    0.1344    0.7056
         0         0         0    0.1600         0         0         0    0.8400
         0         0         0         0    0.0320    0.1280    0.1680    0.6720
         0         0         0         0         0    0.1280         0    0.8720
         0         0         0         0         0         0    0.1600    0.8400
         0         0         0         0         0         0         0    1.0000 ];
 P1(:,:,2) =  [ 0.0400         0    0.1600         0    0.1600         0    0.6400         0
    0.0160    0.0160    0.0840    0.0840    0.0640    0.0640    0.3360    0.3360
         0         0    0.1600         0         0         0    0.8400         0
         0         0    0.0800    0.0800         0         0    0.4200    0.4200
         0         0         0         0    0.1600         0    0.8400         0
         0         0         0         0    0.0640    0.0640    0.4360    0.4360
         0         0         0         0         0         0    1.0000         0
         0         0         0         0         0         0    0.5000    0.5000];
P1(:,:,3) =  [ 0.0400    0.1600         0         0    0.1600    0.6400         0         0
         0    0.2000         0         0         0    0.8000         0         0
    0.0128    0.0672    0.0128    0.0672    0.0672    0.3528    0.0672    0.3528
         0    0.0800         0    0.0800         0    0.4200         0    0.4200
         0         0         0         0    0.2000    0.8000         0         0
         0         0         0         0         0    1.0000         0         0
         0         0         0         0    0.0800    0.4200    0.0800    0.4200
         0         0         0         0         0    0.5000         0    0.5000];
P1(:,:,4) = [  0.2000         0         0         0    0.8000         0         0         0
    0.1000    0.1000         0         0    0.4000    0.4000         0         0
    0.0800         0    0.0800         0    0.4200         0    0.4200         0
    0.0400    0.0400    0.0400    0.0400    0.2100    0.2100    0.2100    0.2100
         0         0         0         0    1.0000         0         0         0
         0         0         0         0    0.5000    0.5000         0         0
         0         0         0         0    0.5000         0    0.5000         0
         0         0         0         0    0.2500    0.2500    0.2500    0.2500];
P1(:,:,5) = [  0.0400    0.1600    0.1600    0.6400         0         0         0         0
         0    0.1600         0    0.8400         0         0         0         0
         0         0    0.1600    0.8400         0         0         0         0
         0         0         0    1.0000         0         0         0         0
    0.0160    0.0640    0.0840    0.3360    0.0160    0.0640    0.0840    0.3360
         0    0.0640         0    0.4360         0    0.0640         0    0.4360
         0         0    0.0800    0.4200         0         0    0.0800    0.4200
         0         0         0    0.5000         0         0         0    0.5000];
P1(:,:,6) =  [ 0.2000         0    0.8000         0         0         0         0         0
    0.0800    0.0800    0.4200    0.4200         0         0         0         0
         0         0    1.0000         0         0         0         0         0
         0         0    0.5000    0.5000         0         0         0         0
    0.0800         0    0.4200         0    0.0800         0    0.4200         0
    0.0320    0.0320    0.2180    0.2180    0.0320    0.0320    0.2180    0.2180
         0         0    0.5000         0         0         0    0.5000         0
         0         0    0.2500    0.2500         0         0    0.2500    0.2500];
P1(:,:,7) =  [0.2000    0.8000         0         0         0         0         0         0
         0    1.0000         0         0         0         0         0         0
    0.0800    0.4200    0.0800    0.4200         0         0         0         0
         0    0.5000         0    0.5000         0         0         0         0
    0.1000    0.4000         0         0    0.1000    0.4000         0         0
         0    0.5000         0         0         0    0.5000         0         0
    0.0400    0.2100    0.0400    0.2100    0.0400    0.2100    0.0400    0.2100
         0    0.2500         0    0.2500         0    0.2500         0    0.2500];
P1(:,:,8) =  [1.0000         0         0         0         0         0         0         0
    0.5000    0.5000         0         0         0         0         0         0
    0.5000         0    0.5000         0         0         0         0         0
    0.2500    0.2500    0.2500    0.2500         0         0         0         0
    0.5000         0         0         0    0.5000         0         0         0
    0.2500    0.2500         0         0    0.2500    0.2500         0         0
    0.2500         0    0.2500         0    0.2500         0    0.2500         0
    0.1250    0.1250    0.1250    0.1250    0.1250    0.1250    0.1250    0.1250 ];
R1 =  [    24    16    16     8    16     8     8     0
    20    16    12     8    12     8     4     0
    20    12    16     8    12     4     8     0
    16    12    12     8     8     4     4     0
    20    12    12     4    16     8     8     0
    16    12     8     4    12     8     4     0
    16     8    12     4    12     4     8     0
    12     8     8     4     8     4     4     0   ];


%% Test 2 - Test gmdp_eval_policy_MF with default arguments
Vloc2{1} = [ 24.6623   24.6623   20.0000   20.0000 ]';
Vloc2{2} = [ 24.5803   24.5803   20.0000   20.0000   24.5803   24.5803   20.0000   20.0000 ]';
Vloc2{3} = [ 24.6623   20.0000   24.6623   20.0000 ]';


%% Test 3 - Test gmdp_eval_policy_MF with different policyloc and Qloc0
Vloc3{1} = [ 0 0 0 0 ]';
Vloc3{2} = [ 0 0 0 0 0 0 0 0 ]';
Vloc3{3} = [ 0 0 0 0 ]';


%% Test 4 - Test gmdp_eval_policy_MF with different policyloc, Qloc0 and Tend
Vloc4{1} = [ 10.2869    9.5637    6.6518    1.9928 ]';
Vloc4{2} = [ 10.7700    1.1581    6.2374    0.9354   10.7700    1.1581    6.2374    0.9354 ]';
Vloc4{3} = [ 10.2221    5.7351    0.8077    0.6307 ]';


%% Test 5 - Test gmdp_policy_iteration_MF with default arguments
policyloc5{1}=[ 1     1     1     1 ]';
policyloc5{2}=[ 1     1     1     1     1     1     1     1 ]';
policyloc5{3}=[ 1     1     1     1 ]';
Vloc5{1}=[ 24.6623   24.6623   20.0000   20.0000 ]';
Vloc5{2}=[ 24.5803   24.5803   20.0000   20.0000   24.5803   24.5803   20.0000   20.0000 ]';
Vloc5{3}=[ 24.6623   20.0000   24.6623   20.0000 ]';
iter5=10;


%% Test 6 - Test gmdp_policy_iteration_MF with different policyloc, max_iter and max_iter_update
policyloc6{1}=[ 1     1     1     1 ]';
policyloc6{2}=[ 2     2     2     1     2     2     1     1 ]';
policyloc6{3}=[ 1     1     1     1 ]';
Vloc6{1}=[ 24.6745   24.6745   20.0000   20.0000 ]';
Vloc6{2}=[ 0         0   13.8602   17.9534         0         0   17.9534   17.9534 ]';
Vloc6{3}=[ 24.6745   20.0000   24.6745   20.0000 ]';
iter6=2;


%% Test 7 - Test gmdp_linear_programming
policyloc7{1}=[ 1     1     1     1 ]';
policyloc7{2}=[ 1     1     1     1     1     1     1     1 ]';
policyloc7{3}=[ 1     1     1     1 ]';
